(function () {
    'use strict'
    angular.module('Corporativo.Core').directive('cronometro', cronometro);
    
    function cronometro() {
        return {
            restrict: 'E',
            link: function (scope, element, attrs) { },
            scope: {},
            template:
                '<div class="modal fade" id="confirmacion" tabindex="-1" data-backdrop="static" style="z-index: 5055" role="dialog" aria-labelledby="confirmacion" aria-hidden="true" modal>' +
                '<div class="modal-dialog modal-md modal-dialog-centered" role="document">' +
                '<div class="modal-content text-center">' +
                '<div class="modal-body text-center pt-4">' +
                '<div class="container-modal tbl-gral">' +
                '<div class="row justify-content-center">' +
                '<span>Tu sesi&oacute;n est&aacute; por finalizar, para continuar operando haz clic en el boton "Continuar", de lo contrario en "Cerrar" para finalizar tu sesi&oacute;n</span>' +
                '</div>' +
                '</div>' +
                '</div>' +
                '<div class="row">' +
                '<div class="title-page w-100 text-center">' +
                '<button ng-disabled="crono.disabledButtons" type="button" class="btn btn-primary btn-cartera d-inline-flex  text-center mb-2 mr-2 btn-session" ng-click="crono.continuar()">' +
                '<span class="pl-3 pr-3">Continuar</span>' +
                '</button>' +
                '<button ng-disabled="crono.disabledButtons" type="button" class="btn btn-primary btn-cartera d-inline-flex  text-center mb-2 btn-session" ng-click="crono.terminar()">' +
                '<span class="pl-3 pr-3">Cerrar</span>' +
                '</button>' +
                '</div>' +
                '</div>' +
                '</div>' +
                '</div>' +
                '</div>',
            controller: CronometroCtrl,
            controllerAs: "crono"
        };
    }
    
    CronometroCtrl.$inject = ['$interval','$timeout','UsuarioService','ModalServices','RedireccionServices','StorageService','HomeServices'];
    function CronometroCtrl($interval, $timeout, Usuario, ModalSvc, RedireccionSvc, StorageSvc,HomeServices) {
        let vm = this;
        let conteoInactividad = "";
        let intervalo = "";
        const tiempoInicial = 270000;
        const tiempoModal = 30000;
        const tiempoMaximo = 1200000;
        vm.continuar = continuar;
        vm.terminar = terminar;
        vm.disabledButtons=false;

        arranque();
        conteoMaximo();
        function arranque() {
            $timeout(() => {
                conteo(tiempoInicial / 1000);
                $timeout(() => {
                    abrirModal();
                }, tiempoInicial);
            }, 0);
        }
        function conteoMaximo(){
            $timeout(() => {
                terminar();
            },tiempoMaximo);
        }

        function terminaSesion() {
            Usuario.remover(true);
            StorageSvc.limpiar();
            RedireccionSvc.login();
        }
        
        function abrirModal() {
            ModalSvc.AbrirModal('confirmacion');
            conteo(tiempoMaximo / 1000);
            conteoInactividad = $timeout(() => {
                vm.disabledButtons=true;
                terminar();  
            }, tiempoModal);
        }
        
        function conteo(segundos) {
            intervalo = $interval(function () {
            }, 1000, segundos);
        }
        
        function continuar() {
            let cuerpo ={
                'idPersona' : Usuario.info.idPersona,
                'idSesion' : Usuario.info.idSesion
            }
            $timeout.cancel(conteoInactividad);
            conteoInactividad = "";
            intervalo = "";
            ModalSvc.CerrarModal('confirmacion');
            arranque();
            HomeServices.actualizarSesion(cuerpo);
        }
        
        function terminar() {
            let cuerpo = {
                'idSesion' : Usuario.info.idSesion
            }
            ModalSvc.CerrarModal('confirmacion');
            $interval.cancel(intervalo);
            $timeout.cancel(conteoInactividad);
            HomeServices.cerrarSesion(cuerpo).then(exito,error);
        }
        function exito(res) {
            terminaSesion();
        }
        function error(res) {
            terminaSesion();
        }
    }
})();